-------------------WiP-------------------
---"Ctf Essentials script by The Camo"---
-----------------------------------------

-----Pre Load!----- NOTE: Do not change any of these if you don't know what you are doing!
if ctfe==nil then ctfe={} end
rtw=0
btw=0
rf=" "
bf=" "
function ctfe.usgns(table,id)
	for _, ctfeusgn in ipairs(table) do
		if player(id,"usgn") == ctfeusgn then
		return true
		end
	end
return false
end
-------------------

-----Settings!----- NOTE: Every option can be set to what ever if you want to turn it off, only thing that will turn it on is "ON"!
ctfe.admins={7235}				--Add new Admin's usgns here to have their chat suffixed along with prefix.
WelcomeMessage="on"				--Change this if you don't want the welcome message to be displayed.
OnJoinChangePlayerName="on"			--Change this if you don't want the server to change "player" names.
OnJoinChangePlayerNameTo="NewGuy"		--Change this to set a new player name, works only if OnJoinChangePlayerName="YES".
ColorChatByTeams="on"				--Change this if you don't want teams to have their chat color blue and prefixes in them. NOTE: Any other "say" hooks will make conflict with this one! thus, this one will not work.
CountFlagReturns="on"				--Change this if you don't want the flagcaptures to be counted.
MaxPlayerLimitToOneTeam="on"			--Change this if you don't want teams to be limited to 16(half of max number(32)) players. NOTE: This value is not changeable!
-------------------

-------Hooks------- NOTE: Do not change any of these if you don't know what you are doing!
addhook ("serveraction","ctfe.serveraction")
addhook ("flagcapture","ctfe.captureflag")
addhook ("ms100","ctfe.mstimed")
addhook ("sayteam","ctfe.say")
addhook ("team","ctfe.team")
addhook ("join","ctfe.join")
addhook ("say","ctfe.say")
-------------------

---Actual Script--- NOTE: Do not change any of these if you don't know what you are doing!
function ctfe.team(id,team)
	if string.lower(MaxPlayerLimitToOneTeam)=="on" then
	tts=player(0,"team1"); tts=#tts
	ctts=player(0,"team2"); ctts=#ctts
		if team==1 and tts>=16 then
		parse ("sv_msg2 "..id.." 255025000 You can't join Red Team, maximum number of players per team is 16! @C")
		return 1
		elseif team==2 and ctts>=16 then
		parse ("sv_msg2 "..id.." 050150255 You can't join Blue Team, maximum number of players per team is 16! @C")
		return 1
		elseif team==0 then
			if tts<=ctts and tts<16 then
			parse ("maket "..id)
			parse ("sv_msg2 "..id.." 255025000 You can't join Spectators, you have been switched to Red Team @C")
			elseif ctts<tts and ctts<16 then
			parse ("makect "..id)
			parse ("sv_msg2 "..id.." 050150255 You can't join Spectators, you have been switched to Blue Team @C")
			end
		end
	end
end

function ctfe.join(id)
	if string.lower(WelcomeMessage)=="on" then
		if player(id,"usgn")==0 then
		parse ("sv_msg2 "..id.." 000200000Welcome "..player(id,"name")..". Chose your Side! @C")
		else
		parse ("sv_msg2 "..id.." 000200000Welcome "..player(id,"name").." ["..player(id,"usgn").."]. Chose your Side! @C")
		end
	end
	if player(id,"name")=="Player" and OnJoinChangePlayerName=="YES" then
	parse("setname "..id.." "..OnJoinChangePlayerNameTo)
	end
end

function ctfe.captureflag(id,team)
	if string.lower(CountFlagReturns)=="on" then
		if (player(id,"team"))==1 then
		rtw=rtw+1
		parse ("sv_msg2 "..id.." 255025000 You have captured the Blue Flag!")
		elseif (player(id,"team"))==2 then
		btw=btw+1
		parse ("sv_msg2 "..id.." 050150255 You have captured the Red Flag!")
		end
	end
end

function ctfe.mstimed()
bf=" "
rf=" "
	for id=1,32 do
		if(player(id,"flag")==true) then
			if (player(id,"team")==1) then
			bf="(Taken)"
			elseif (player(id,"team")==2) then
			rf="(Taken)"
			end
		end
	end
	for all=1,32 do
	parse('hudtxt2 '..all..' 1ht "050150255 Blue Team: '..btw..' '..bf..'" 279 15')
	parse('hudtxt2 '..all..' 2ht "255025000 Red Team: '..rtw..' '..rf..'" 280 30')
	end
end

function ctfe.say(id,txt)
	if txt~="" and string.lower(ColorChatByTeams)=="on" then
		if (ctfe.usgns(ctfe.admins,id))==true then
			if player(id,"team")== 1 then
			local colortext=string.sub(txt,1,string.len(txt))
			msg ("255025000[Red Team] "..player(id,"name").." [Admin]: "..colortext)
			return 1
			elseif player(id,"team")== 2 then
			local colortext=string.sub(txt,1,string.len(txt))
			msg ("050150255[Blue Team] "..player(id,"name").." [Admin]: "..colortext)
			return 1
			elseif player(id,"team")== 0 then
			local colortext=string.sub(txt,1,string.len(txt))
			msg ("250250050[Spectator] "..player(id,"name").." [Admin]: "..colortext)
			return 1
			end
		end
		if (ctfe.usgns(ctfe.admins,id))==false then
			if player(id,"team")== 1 then
			local colortext=string.sub(txt,1,string.len(txt))
			msg ("255025000[Red Team] "..player(id,"name")..": "..colortext)
			return 1
			elseif player(id,"team")== 2 then
			local colortext=string.sub(txt,1,string.len(txt))
			msg ("050150255[Blue Team] "..player(id,"name")..": "..colortext)
			return 1
			elseif player(id,"team")== 0 then
			local colortext=string.sub(txt,1,string.len(txt))
			msg ("250250050[Spectator] "..player(id,"name")..": "..colortext)
			return 1
			end
		end
	end
end

